;Fan-Geschwindigkeit Methoden
GetFanZ:
	cpi tmp1, 0		;Wenn fan0
	breq GetFan0Z
	cpi tmp1, 1		;Wenn fan1
	breq GetFan1Z
	cpi tmp1, 2		;Wenn fan2
	breq GetFan2Z
	cpi tmp1, 3		;Wenn fan3
	breq GetFan3Z
GetFanZ2:
	ret

GetFan0Z:
	ldi ZH, HIGH(0x0062)		;Z neu erstellen
	ldi ZL, LOW(0x0062)
	rjmp GetFanZ2

GetFan1Z:
	ldi ZH, HIGH(0x0063)		;Z neu erstellen
	ldi ZL, LOW(0x0063)
	rjmp GetFanZ2

GetFan2Z:
	ldi ZH, HIGH(0x0064)		;Z neu erstellen
	ldi ZL, LOW(0x0064)
	rjmp GetFanZ2

GetFan3Z:
	ldi ZH, HIGH(0x0065)		;Z neu erstellen
	ldi ZL, LOW(0x0065)
	rjmp GetFanZ2

	;Sendet Geschwindigkeit des aktuellen FANs an die 2 7-Segment-anzeigen (PORTC)
SendFanGes:
	push tmp1				;Bentigte Swaps sichern
	push ZH					;Z sichern
	push ZL
	lds tmp1, aktfan		;Fan-Nummer holen
	rcall GetFanZ			;Z ermitteln
	ld tmp1, Z				;Fan-Geschwindigkeit holen
	rcall BinToBcd			;Geschwindigkeit in BCD umwandeln
	out PORTC, tmp1			;Geschwindigkeit wird an PortC ausgegeben
	pop ZL					;Sicherungen in umgekehrter reihenfolge zurckholen
	pop ZH
	pop tmp1
	ret						;Zurck

BinToBcd: 					;Bereitet tmp2 fr die verwendung vor
	push tmp2				;Erst sichern...
	clr tmp2				;Dann alle bits auf 0 setzen

BinToBcd2:
	cpi tmp1, 10			;Vergleichen mit 10
	brcs BinToBcd3			;wenn kleiner zurck
	inc tmp2				;zehner zhlen
	subi tmp1, 10			;10 abziehen
	rjmp BinToBcd2			;zurck zum Anfang bis tmp1 < 10

BinToBcd3:
	swap tmp2				;Nibbles tauschen
	or tmp1, tmp2			;Logisches OR (vorderes nibble von tmp2 hinteres von tmp1)
	pop tmp2				;tmp2 zurckholen
	ret						;Zurck

UpperFan0:
	LDI tmp2, 10			;10 in tmp2 speichern
	ADD fan0, tmp2			;fan0 + tmp2
	rjmp UpperFanGes2		;UpperFanGes beenden

UpperFan1:
	LDI tmp2, 10
	ADD fan1, tmp2
	rjmp UpperFanGes2

UpperFan2:
	LDI tmp2, 10
	ADD fan2, tmp2
	rjmp UpperFanGes2

UpperFan3:
	LDI tmp2, 10
	ADD fan3, tmp2
	rjmp UpperFanGes2

LowerFanGes2:
	rcall SendFanGes		;Geschwindigkeit an Anzeige senden
	pop tmp3
	pop tmp2				;Swaps zurckholen
	pop tmp1
	pop ZH					;Z zurckholen
	pop ZL
	rjmp PushLeft2			;Zurck

LowerFanGes:
	push tmp1				;Bentigte Swaps sichern
	push tmp2
	push tmp3
	push ZH					;Z sichern
	push ZL
	LDS tmp1, aktfan		;Fan-Nummer holen
	rcall GetFanZ			;Z ermitteln
	LD tmp2, Z				;Fan-Geschwindigkeit holen
	cpi tmp2, 0				;Testen ob FanGes == 0
	breq LowerFanGes2		;Wenn TRUE: zurck
	DEC tmp2				;Fangeschwindigkeit +1
	ST Z, tmp2				;Fangeschwindigkeit sichern
	cpi tmp1, 0				;Testen ob Fan0
	breq LowerFan0
	cpi tmp1, 1				;Testen ob Fan1
	breq LowerFan1
	cpi tmp1, 2				;Testen ob Fan2
	breq LowerFan2
	cpi tmp1, 3				;Testen ob Fan3
	breq LowerFan1

UpperFanGes:
	push tmp1				;Bentigte Swaps sichern
	push tmp2
	push tmp3
	push ZH					;Z sichern
	push ZL
	LDS tmp1, aktfan		;Fan-Nummer holen
	rcall GetFanZ			;Z ermitteln
	LD tmp2, Z				;Fan-Geschwindigkeit holen
	cpi tmp2, 20			;Testen ob FanGes == 20
	breq UpperFanGes2		;Wenn TRUE: zurck
	INC tmp2				;Fangeschwindigkeit +1
	ST Z, tmp2				;Fangeschwindigkeit sichern
	cpi tmp1, 0				;Testen ob Fan0
	breq UpperFan0
	cpi tmp1, 1				;Testen ob Fan1
	breq UpperFan1
	cpi tmp1, 2				;Testen ob Fan2
	breq UpperFan2
	cpi tmp1, 3				;Testen ob Fan3
	breq UpperFan1

UpperFanGes2:
	rcall SendFanGes		;Geschwindigkeit an Anzeige senden
	pop tmp3
	pop tmp2				;Swaps zurckholen
	pop tmp1
	pop ZH					;Z zurckholen
	pop ZL
	rjmp PushRight2			;Zurck

;Tasten methoden
PushLeft:
	sbrc taster, 0			;wenn taster gedrckt gewesen
	rjmp checktaster		;Zurck
	cpi menureg, 0			;wenn nicht im men
	breq LowerFanGes		;Fan-Geschwindigkeit runtersetzen
	cpi menureg, 1			;wenn im men
	breq DecFan				;FanNR runtersetzen
PushLeft2:
	sbr taster, 1			;Taster gedrckt
	rjmp checktaster		;Zurck

PushRight:
	sbrc taster, 2			;wenn taster gedrckt gewesen
	rjmp checktaster		;Zurck
	cpi menureg, 0			;wenn nicht im men
	breq UpperFanGes		;Fan-Geschwindigkeit runtersetzen
	cpi menureg, 1			;wenn im men
	breq IncFan				;FanNR runtersetzen
PushRight2:
	sbr taster, 4			;Taster gedrckt
	rjmp checktaster		;Zurck

PushMenu:
	sbrc taster, 1			;wenn taster gedrckt gewesen
	rjmp checktaster		;Zurck
	cpi menureg, 0			;wenn nicht men
	breq JoinMenu			;ins men gehen
	cpi menureg, 1			;wenn im men
	breq PartMenu			;aus men rausgehen
PushMenu2:
	sbr taster, 2			;Taster gedrckt
	rjmp checktaster		;Zurck

LowerFan0:
	ldi tmp2, 10
	sub fan0, tmp2
	rjmp LowerFanGes2

LowerFan1:
	ldi tmp2, 10
	sub fan1, tmp2
	rjmp LowerFanGes2

LowerFan2:
	ldi tmp2, 10
	sub fan2, tmp2
	rjmp LowerFanGes2

LowerFan3:
	ldi tmp2, 10
	sub fan3, tmp2
	rjmp LowerFanGes2

;FanNR methoden
SendFan:
	push tmp1				;tmp1 sichern
	push tmp2
	ldi tmp2, 1
	lds tmp1, aktfan		;FanNR holen
	add tmp1, tmp2			;+1
	out PORTC, tmp1			;FanNR ausgeben (tmp1<10, darum keine umwandlung zu BCD)
	pop tmp2
	pop tmp1
	ret
		
IncFan:
	push tmp1				;tmp1 sichern
	lds tmp1, aktfan		;FanNR holen
	cpi tmp1, 3				;Wenn FanNR == 3
	breq IncFan2			;beenden
	inc tmp1				;Inc FanNR
	sts aktfan, tmp1		;Neue FanNR speichern
	rcall SendFan			;FanNR anzeigen
IncFan2:
	pop tmp1				;tmp1 zurckholen
	rjmp PushRight2			;zurck

DecFan:
	push tmp1				;tmp1 sichern
	lds tmp1, aktfan		;FanNR holen
	cpi tmp1, 0				;Wenn Fan == 0
	breq DecFan2			;beenden
	dec tmp1				;Dec FanNR
	sts aktfan, tmp1		;Neue FanNR speichern
	rcall SendFan			;FanNR anzeigen
DecFan2:
	pop tmp1				;tmp1 zurckholen
	rjmp PushLeft2			;zurck

JoinMenu:
	push tmp1				;tmp1 sichern
	ldi tmp1, 1				;menu auf 1 setzen
	mov menureg, tmp1
	rcall SendFan
	sbi PORTB, menuled		;LED an
	pop tmp1				;tmp1 zurckholen
	rjmp PushMenu2			;zurck

PartMenu:
	push tmp1				;tmp1 sichern
	ldi tmp1, 0				;menu auf 0 setzen
	mov menureg, tmp1
	rcall SendFanGes
	cbi PORTB, menuled		;LED aus
	pop tmp1				;tmp1 zurckholen
	rjmp PushMenu2			;zurck
