.NOLIST
.INCLUDE "equals.inc"
.LIST

.equ menuled= 4
.equ leftbit= 5
.equ menubit= 6
.equ rightbit=7
.equ aktfan = 0x0060
.def fan0	= R10
.def fan1	= R11
.def fan2	= R12
.def fan3	= R13
.def menureg= R22
.def tmp1	= R16
.def tmp2	= R17
.def tmp3	= R18
.def tmp4	= R19
.def tmp5	= R20
.def taster	= R21
.def counter= R23
.equ schritte = 201

	rjmp main
	reti
	reti
	reti
	reti
	reti
	rjmp pwmtimer
	reti
	reti
	reti
	reti
	reti
	reti
	reti
	reti
	reti
	reti
	reti
	reti
	reti
	reti

.include "InputMethods.inc"		;Input-methoden einfgen
.include "PWMMethods.inc"		;PWM-methods einfgen


main:
	;stack initialisieren!!
	LDI tmp1, HIGH(RAMEND)		;Oberes Byte
    OUT SPH, tmp1				 ;an Stapelzeiger
    LDI tmp1, LOW(RAMEND)		;Unteres Byte
    OUT SPL, tmp1				;an Stapelzeiger

	;Timer initialisieren
	ldi tmp1, 0x8A
	out TCCR2, tmp1				;Timermodi setzen (10001010)
	ldi tmp1, 100
	out OCR2, tmp1				;compare-int setzen
	ldi tmp1, 0x80				; Bit 7 setzen
	OUT TIMSK, tmp1				; in Timer Interupt Mask Register
	sei

	;IOs initialisieren
	ldi tmp1, 0x1F				;PORTB 0-4 OUT
	out DDRB, tmp1
	ldi tmp1, 0xFF				;PORTC OUT
	out DDRC, tmp1
	ldi tmp1, 0x00				;PORTD IN
	out DDRD, tmp1

	;Anzeige initialisieren
	ldi tmp1, 0					;aktfan auf 0 setzen
	sts aktfan, tmp1			
	sts 0x0062, tmp1			;Fan-geschwindigkeiten auf 0 setzen
	sts 0x0063, tmp1
	sts 0x0064, tmp1
	sts 0x0065, tmp1
	rcall JoinMenu

inputloop:
	in tmp1, PORTD
	sbrc tmp1, leftbit			;Wenn leftbit == 1
	rcall PushLeft				;PushLeft ausfhren
	sbrc tmp1, menubit			;Wenn menubit == 1
	rcall PushMenu				;PushMenu ausfhren
	sbrc tmp1, rightbit			;Wenn rightbit == 1
	rcall PushRight				;PushRight ausfhren
checktaster:
	sbrs tmp1, 0				;wenn taster nicht gedrckt
	cbr taster, 1				;taster auf 0 setzen
	sbrs tmp1, 1				;wenn taster nicht gedrckt
	cbr taster, 2				;taster auf 0 setzen
	sbrs tmp1, 2				;wenn taster nicht gedrckt
	cbr taster, 4				;taster auf 0 setzen
	rjmp inputloop				;Von vorne!